(* Code of Figure 9.13, page 382 from
   Kenneth C. Louden, Programming Languages
   Principles and Practice 2nd Edition
   Copyright (C) Brooks-Cole/ITP, 2003
*)

signature QUEUE =
   sig
   type 'a Queue
   val createq: 'a Queue
   val enqueue: 'a Queue * 'a -> 'a Queue
   val frontq: 'a Queue -> 'a
   val dequeue: 'a Queue -> 'a Queue
   val emptyq: 'a Queue -> bool
   end;
